<script lang="ts">
import Vue, { PropType } from 'vue';
import {
  CtfEntry,
  CtfTheSourceArticlePage,
  CtfTheSourceAuthor,
  CtfTheSourceCategory,
} from '~/models';
import { getUrlFromContentfulImage } from '~/common/util';
import { IsMobileMixin } from '~/mixins';
import { THE_SOURCE_TYPES } from '~/common/constants';

export default Vue.extend({
  name: 'TheSourceFeatured',
  mixins: [IsMobileMixin],
  props: {
    article: {
      type: Object as PropType<CtfTheSourceArticlePage>,
      required: true,
    },
    recent: {
      type: Array as PropType<CtfEntry<CtfTheSourceArticlePage>[]>,
      required: true,
    },
  },
  data() {
    return {
      isHeadlineHighlighted: false,
      types: THE_SOURCE_TYPES,
    };
  },
  computed: {
    articleImage() {
      return getUrlFromContentfulImage(this.article.heroImage, 1460, 760);
    },
    alt() {
      return this.article?.heroImage?.fields?.description;
    },
    mostRecentArticles(): CtfTheSourceArticlePage[] {
      return this.recent?.map((article) => article.fields) || [];
    },
    author(): CtfTheSourceAuthor {
      return this.article?.author?.fields;
    },
    category(): CtfTheSourceCategory {
      return this.article?.category?.fields;
    },
    showIcon(): boolean {
      return this.article?.type !== THE_SOURCE_TYPES.REGULAR;
    },
  },
});
</script>

<template>
  <div class="ts-featured">
    <SlpContainer>
      <SlpRow>
        <!-- FEATURED ARTICLE -->
        <SlpColumn :cols="8" class="slp-pr-md-24 ts-featured__container">
          <SlpButton
            :href="`/${article.slug}/`"
            variant="ghost"
            class="ts-featured__image"
            @mouseover.native="isHeadlineHighlighted = true"
            @mouseleave.native="isHeadlineHighlighted = false"
          >
            <img :src="articleImage" :alt="alt" />
          </SlpButton>
          <div class="ts-featured__article">
            <div class="slp-flex">
              <SlpIcon
                v-if="showIcon"
                name="lock"
                variant="product"
                class="slp-mr-4"
              />
              <SlpTypography tag="h5" variant="all-caps">{{
                $t(
                  `articles.${article.type ? article.type.toLowerCase() : 'article'}`,
                )
              }}</SlpTypography>
            </div>
            <SlpButton
              :href="`/${article.slug}/`"
              variant="tertiary"
              :class="[
                'ts-featured__headline',
                { 'ts-featured__headline--active': isHeadlineHighlighted },
              ]"
            >
              <SlpTypography
                tag="h3"
                variant="heading3-bold"
                class="slp-mb-8"
                >{{ article.headline }}</SlpTypography
              >
            </SlpButton>
            <SlpTypography
              v-if="article.description"
              tag="p"
              variant="body1"
              class="slp-mb-8"
              >{{ article.description }}</SlpTypography
            >
            <div class="ts-featured__btn-group">
              <SlpButton
                v-if="category"
                :href="`/${category.slug}/`"
                variant="tertiary"
              >
                <SlpTypography tag="span" variant="body3-bold">{{
                  category.title
                }}</SlpTypography>
              </SlpButton>
              <span v-if="category && author" class="separator" />
              <SlpButton
                v-if="author"
                :href="`/${author.slug}/`"
                variant="tertiary"
                ><SlpTypography tag="span" variant="body3-bold">
                  {{ author.name }}</SlpTypography
                ></SlpButton
              >
            </div>
          </div>
        </SlpColumn>
        <!-- MOST RECENT ARTICLES -->
        <SlpColumn :cols="4" class="w-100">
          <div id="most-recent-articles" class="ts-featured__recent">
            <SlpTypography class="slp-mb-16" tag="h4" variant="all-caps">{{
              $t('articles.mostRecent')
            }}</SlpTypography>
            <div
              v-for="item in mostRecentArticles"
              :key="item.title"
              class="ts-featured__recent-item"
            >
              <div class="slp-flex slp-mt-16">
                <SlpIcon
                  v-if="item.type !== types.REGULAR"
                  name="lock"
                  variant="product"
                  class="slp-mr-4"
                />
                <SlpTypography tag="h5" variant="all-caps">{{
                  $t(
                    `articles.${item.type ? item.type.toLowerCase() : 'article'}`,
                  )
                }}</SlpTypography>
              </div>
              <SlpButton :href="`/${item.slug}/`" variant="tertiary">
                <SlpTypography tag="span" variant="body2-bold">{{
                  item.headline
                }}</SlpTypography>
              </SlpButton>
              <div
                v-if="item.category || item.author"
                class="ts-featured__btn-group"
              >
                <SlpButton
                  v-if="item.category"
                  :href="`/${item.category.fields.slug}/`"
                  variant="tertiary"
                >
                  <SlpTypography tag="span" variant="body3-bold">{{
                    item.category.fields.title
                  }}</SlpTypography>
                </SlpButton>
                <span v-if="item.author" class="separator" />
                <SlpButton
                  v-if="item.author"
                  :href="`/${item.author.fields.slug}/`"
                  variant="tertiary"
                  ><SlpTypography tag="span" variant="body3-bold">
                    {{ item.author.fields.name }}</SlpTypography
                  ></SlpButton
                >
              </div>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.separator {
  border-left: 1px solid $color-surface-400;
  height: 12px;
  margin: 0 $spacing-8;
}

.ts-featured {
  padding: $spacing-32 0 $spacing-32 0;
  background-color: $color-surface-100;

  @media (min-width: $breakpoint-md) {
    padding: $spacing-64 0;
  }

  &__image {
    width: 100%;
    padding: 0;

    img {
      width: 100%;
      border-radius: 8px;
    }
  }

  &__headline {
    text-align: start;
    padding: 0;

    &:hover {
      color: $color-text-link-100;
      text-decoration-color: $color-text-link-100;
    }

    &--active {
      color: $color-text-link-100;
      text-decoration-color: $color-text-link-100;
    }
  }

  &__article {
    padding: $spacing-16 0;

    @media (min-width: $breakpoint-md) {
      padding: $spacing-16;
    }
  }

  &__recent {
    margin: $spacing-24 0 0 0;
    padding: $spacing-24;
    background-color: white;
    border-radius: $spacing-8;
    width: 100%;

    @media (min-width: $breakpoint-md) {
      margin: 0;
    }
  }

  &__recent-item {
    display: flex;
    flex-direction: column;
    border-top: 1px solid $color-surface-300;
    margin: $spacing-16 0;
    text-align: start;

    &:first-of-type {
      margin-top: 0;
    }

    &:last-of-type {
      margin-bottom: 0;
    }

    .slp-btn {
      text-align: start;
      padding: $spacing-8 0;

      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }
    }
  }

  &__btn-group {
    display: flex;
    align-items: center;
    text-align: start;

    .slp-btn {
      padding: 0;
      text-align: start;

      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }
    }
  }

  #most-recent-articles {
    @media ($breakpoint-md <= width <= $breakpoint-lg), (width <= 375px) {
      .separator {
        display: none;
      }

      .ts-featured__btn-group {
        align-items: flex-start;
        flex-direction: column;
      }
    }
  }
}
</style>
